(function() {
    var area2d = document.createElement("div");
    area2d.style.width = "100%";
    area2d.style.height = "100%";
 
    var viewerData;
    var viewerDesign;
 
    if (document.body) {
        document.body.appendChild(area2d);
        document.body.style.margin = "0px";
        document.body.style.padding = "0px";
    } else {
        window.onload = function() {
            document.body.appendChild(area2d);
            document.body.style.margin = "0px";
            document.body.style.padding = "0px";
        }
    }

    var iFrame;
    function notifyNative(event) {
        iFrame = document.createElement("IFRAME");
        iFrame.setAttribute("src", "about:" + event);
        document.body.appendChild(iFrame);
        iFrame.parentNode.removeChild(iFrame);
        iFrame = null;
    }

    function updateViewer() {
        fpViewer.display2D(viewerDesign, null, function() { notifyNative("render2dReady"); });
    }

    window.fpViewerIOS = {
        loadProject: function(options) {
            fpViewer.init({
                box2d: area2d,
                theme: theme,
                fml: options.fml,
                callback: function(data) {
                    viewerData = data;
                    notifyNative("projectLoaded");
                },
                onError: function() {
                    notifyNative("projectLoadFailed");
                }
            });
        },

        loadDesign: function(designId) {
            for (var i=0; i<viewerData.floors.length; i++) {
                var floor = viewerData.floors[i];

                for (var j=0; j<floor.designs.length; j++) {
                    var design = floor.designs[j];

                    if (design.state != null && design.state.id == designId) {
                        viewerDesign = design;
                        updateViewer();
                    }
                }
            }
        }
    };

})();
